unit Unit1;

{
Programmfunktion:
           adsb
Hersteller:
           LinSoft Jürgen linder (juelin) dg5uap@darc.de
Lizens:
           privat
Hardware:
           RTL2832SDR
Software:
           Folgende Files
           adsb.exe, adsb.ico, adsb.lpi, adsb.lpr, adsb.lps, adsb.res, rtl_sdr.pas, librtlsdr.dll, unit1.lfm, unit1.pas müssen im Soucepfad vorhanden sein

wie Compelieren:
           Lazarus IDE mit FPC
wie Ausführen:
           Ausführen adsb.exe (Icon)
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  rtl_sdr, StdCtrls, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
  public
    procedure Zeile1(anzzeile: TLabel);                                         // Anzeigen Zeile1 mit Form#.Label# in anzzeile
  end;

const
  ADSB_RATE: longInt = 2000000;                                                 // Sample Rate in Saples/Sekunde
  ADSB_FREQ: longInt = 1090000000;                                              // ADS-B Frequenz in Hz
  DEFAULT_ASYNC_BUF_NUMBER: integer = 12;                                       // Anzahl Puffer
  DEFAULT_BUF_LENGTH: LongInt =	16*16384;                                       // Puggergröße in Byte
  AUTO_GAIN: integer = -100;                                                    // Lautstärke

var
  Form1: TForm1;
  JaNein: word;                                                                 // Ergebnis Ja/Nein Abfrage
  Closestat: integer;                                                           // Merker ob Programm beendet werden darf. 0=Ja 1=Nein
  abbruch: Boolean;                                                             // Programm-Abbruch. Wenn True wird ohne Abfrage das Programm abgebrochen
  mtasts: integer;                                                              // Dürfen die Buttons betätigt werden. 1=Ja 0=Nein
  mlauf: integer;                                                               // Welche Eingabe ist zulässig (1..n) 0=keine Eingabe
  Tag: integer;                                                                 // Datum Tag
  Monat: integer;                                                               // Datum Monat
  Jahr: integer;                                                                // Datum Jahr
  BUser: string;                                                                // Username der angemeldet ist
  sta: integer;                                                                 // Status für Initialisierung der Variablen bei Programmstart. 1=vor Init, 2=nach Init
  vers: string;                                                                 // Versionsnummer des Programms
  anzrec: Integer;                                                              // Anzahl Sätze gelesen aus Datenbank
  sperr: integer;                                                               // Sperre für Buttons 0=gesperrt, 1=frei
  sdrdevice: string;                                                            // Name des SDR-Devices
  msdropen: Boolean;                                                            // SDR-Device geöffnet (True=Ja)
  anzsdr: integer;                                                              // Anzahl SDR-Devices
  msdrreceive: Boolean;                                                         // ASD-B Daten vom SDR-Device werden empfangen
  adsbdev: integer;                                                             // ADS-B Devicenummer
  adsbgen: string;                                                              // ADS-B Devicename
  tuner: string;                                                                // ADS-B Tunername
  sdrdev: longint;                                                              // Devicenummer vom Open SDR
  sdropennum: Prtlsdr_dev_t;                                                    // Opennummer für Close SDR-Device
  buffer: ^byte;                                                                // Puffer für ADS-B Daten vom SDR Device

implementation

{$R *.lfm}

{
  Procedure Zeile1
      zeigt die Zeile1 in Form1.Label1 an
       mit Hersteller, Programmname und Datum
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Zeile1(anzzeile: TLabel);
begin
  anzzeile.Caption:=widechar(169)+'LINSOFT         R T L S D R        ADS-B               Datum: '+FormatDateTime('DD.MM.YYYY',now);
end;

{ TForm1 }

{
Procedure FormCreate
      initialisiert Variable,
      setzt Username, Datum und Programmversion.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormCreate(Sender: TObject);
var
  heute: string;
  h1: integer;
  h3: string;
  Rec: LongRec;
begin
  Closestat:=0;
  mtasts:=1;
  mlauf:=0;
  abbruch:=False;
  BUser:='                                                     ';
  try
    BUser:=SysUtils.GetEnvironmentVariable('USERNAME');
  except
    BUser:='unknown';
  end;
  heute:=FormatDateTime('DD.MM.YYYY',now);
  h1:=StrLen(PChar(heute));
  if (h1 = 10) then
  begin
    h3:=Copy(heute, 1, 2);
    Tag:=StrToInt(h3);
    h3:=Copy(heute, 4, 2);
    Monat:=StrToInt(h3);
    h3:=Copy(heute, 7, 4);
    Jahr:=StrToInt(h3);
  end;
  Rec:=LongRec(GetFileVersion(ParamStr(0)));
  vers:=Format('%.*d.%.*d', [2, Rec.Hi,2, Rec.Lo]);
  abbruch:=false;
  sta:=2;
end;

//rtlsdr_callback(char *buffer, uint32_t len, void nil);
//begin
//  memcpy(buffer, buf, len);
//  safe_cond_signal(&ready, &ready_m);
//end;

{
  Procedure Timer1Timer
      Timer stoppen,
      ADS-B Daten empfangen und anzeigen,
      wenn Empfang gestartet ist Timer wieder starten.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Timer1Timer(Sender: TObject);
  var
    h1: Trtlsdr_read_async_cb_t;
    h2: Tuint32_t;
    h3: Tuint32_t;
    h4: pointer;
    h5: Tuint32_t;
begin
  Timer1.Enabled:=False;
// ' 123456789.123456789.12345678  |  123456789.1234'
  h2:=DEFAULT_ASYNC_BUF_NUMBER;
  h3:=DEFAULT_BUF_LENGTH;
//  h5:=rtlsdr_read_async(sdropennum, h1, h4, h2, h3);
  if msdrreceive then Timer1.Enabled:=True;
end;

{
  Procedure FormClose
      Schließt das Programm
      Close SDR-Device.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  var
    h1: longint;
begin
  Zeile1(Form1.Label1);
  if msdropen then
  begin
    h1:=rtlsdr_close(sdropennum);
    FreeMem(buffer, DEFAULT_BUF_LENGTH * sizeof(byte));
    msdropen:=False;
  end;
  Form1.Cursor:=crDefault;
  Form1.Refresh;
  CloseAction:=caFree;
end;

{
  Procedure FormActivate
      initialisiert Variable,
      setzt Ein- und Ausgabefelder von Form1.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormActivate(Sender: TObject);
  var
    h1: Tuint32_t;
    h2: integer;
    h3: Tuint32_t;
    h4: PChar;
begin
  Zeile1(Form1.Label1);
  Label2.Caption:='';
  Form1.Caption:='             R T L S D R        ADS-B             Programmversion: '+vers+'          Username: '+BUser;
  if sta = 2 then
  begin
    sta:=1;
    mtasts:=1;
    mlauf:=0;
    Closestat:=0;
    sdrdevice:='';
    msdropen:=False;
    anzsdr:=0;
    msdrreceive:=False;
    adsbdev:=0;
    adsbgen:='';
    tuner:='';
    Timer1.Enabled:=False;
    Memo1.Lines.Clear;
    ComboBox1.Text:='';
    ComboBox1.Items.Clear;
    ComboBox1.Color:=clSilver;
    ComboBox1.Enabled:=False;
    ComboBox1.ItemIndex:=-1;
    h1:=rtlsdr_get_device_count;
    if h1 > 0 then
    begin
      anzsdr:=h1;
      for h2:=0 to anzsdr-1 do
      begin
        h3:=h2;
        h4:=rtlsdr_get_device_name(h3);
        ComboBox1.Items.Add(h4);
      end;
    end;
  end;
end;

{
  Procedure Button1Click
      Zur Auswahl des SDR-Devices
      in ComboBox1
      Close SDR-Device.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Button1Click(Sender: TObject);
  var
    h1: longint;
begin
  Zeile1(Form1.Label1);
  Label2.Caption:='';
  if (mtasts = 1) then
  begin
    if not msdrreceive then
    begin
     if anzsdr > 0 then
      begin
        if msdropen then
        begin
          h1:=rtlsdr_close(sdropennum);
          FreeMem(buffer, DEFAULT_BUF_LENGTH * sizeof(byte));
          msdropen:=False;
        end;
        Closestat:=1;
        mtasts:=0;
        mlauf:=1;
        ComboBox1.Color:=clWhite;
        ComboBox1.Enabled:=True;
        Form1.ActiveControl:=ComboBox1;
      end else begin
        Label2.Caption:='kein SDR-Device vorhanden';
      end;
    end else begin
      Label2.Caption:='ADS-B Empfang läuft, erst beenden';
    end;
  end;
end;

{
  Procedure Button2Click
      Holen ADS-B Daten vom SDR-Device
      Starten und Stopen,
      Timer starten.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Button2Click(Sender: TObject);
begin
  Zeile1(Form1.Label1);
  Label2.Caption:='';
  if (mtasts = 1) then
  begin
    if msdropen then
    begin
      if msdrreceive then
      begin
        Button2.Caption:='Start Empfang';
        msdrreceive:=False;
      end else begin
        Memo1.Lines.Add('empfangene ASD-B Daten');
        Memo1.Lines.Add(' Hexadezimal-Werte             |  Ascii-Werte');
        Memo1.Lines.Add('-------------------------------|-----------------');
        Button2.Caption:='Stop Empfang';
        msdrreceive:=True;
        Timer1.Enabled:=True;
      end;
    end else begin
      Label2.Caption:='noch kein SDR-Device ausgewählt';
    end;
  end;
end;

{
  Procedure Button3Click
      Beendet das Programm adsb
      nach Sicherheitsabfrage
      Close SDR-Device.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Button3Click(Sender: TObject);
  var
    h1: longint;
begin
  Zeile1(Form1.Label1);
  Label2.Caption:='';
  if (mtasts = 1) then
  begin
    if (Closestat = 0) then
    begin
      if not msdrreceive then
      begin
        if msdropen then
        begin
          h1:=rtlsdr_close(sdropennum);
          FreeMem(buffer, DEFAULT_BUF_LENGTH * sizeof(byte));
          msdropen:=False;
        end;
        mlauf:=0;
        close;
      end else begin
        Label2.Caption:='ADS-B Empfang läuft, erst beenden';
      end;
    end;
  end;
end;

{
  Procedure ComboBox1Change
      Auswahl des SDR-Devices und Open Device.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.ComboBox1Change(Sender: TObject);
 var
    h1: integer;
    h2: Prtlsdr_dev_t;
    h3: Trtlsdr_tuner;
    h4: Tuint32_t;
    h5: PPrtlsdr_dev_t;
    h6: longint;
    h7: longint;
    h8: Tuint32_t;
begin
  if (mlauf = 1) then
  begin
    Label2.Caption:='';
    if ComboBox1.Text <> '' then
    begin
      sdrdevice:=ComboBox1.Text;
      ComboBox1.Color:=clSilver;
      ComboBox1.Enabled:=False;
      h1:=Length(sdrdevice);
      if h1 > 0 then
      begin
        adsbdev:=ComboBox1.ItemIndex;
        adsbgen:=sdrdevice;
        tuner:='Tuner unbekannt';
        h4:=adsbdev;
        sdrdev:=rtlsdr_open(h5, h4);
        if sdrdev < 0 then
        begin
          Label2.Caption:='SDR Device konnte nicht geöffnet werden';
          mlauf:=0;
          Closestat:=0;
          mtasts:=1;
        end else begin
          sdropennum:=h2;
          h3:=rtlsdr_get_tuner_type(sdropennum);
          if h3 = 1 then tuner:='Tuner E4000';
          if h3 = 2 then tuner:='Tuner FC0012';
          if h3 = 3 then tuner:='Tuner FC0013';
          if h3 = 4 then tuner:='Tuner FC2580';
          if h3 = 5 then tuner:='Tuner R280T';
          if h3 = 6 then tuner:='Tuner R828D';
          GetMem(buffer, DEFAULT_BUF_LENGTH * sizeof(byte));
          Memo1.Lines.Clear;
          Memo1.Lines.Add('ADS-B Device: '+IntToStr(adsbdev)+'    Generic: '+adsbgen);
          Memo1.Lines.Add('Tuner: '+tuner);
          Memo1.Lines.Add('Tuner-Gain: automatisch');
          Memo1.Lines.Add('Tuner-Frequenz: '+IntToStr(ADSB_FREQ)+' Hz');
          Memo1.Lines.Add('Sample-Rate: '+IntToStr(ADSB_RATE)+' S/s');
          Memo1.Lines.Add('');
          msdropen:=True;
          h7:=AUTO_GAIN;
          h6:=rtlsdr_set_tuner_gain(sdropennum, h7);
          h7:=1;
          h6:=rtlsdr_set_agc_mode(sdropennum, h7);
          h8:=ADSB_FREQ;
          h6:=rtlsdr_set_center_freq(sdropennum, h8);
          h8:=ADSB_RATE;
          h6:=rtlsdr_set_sample_rate(sdropennum, h8);
          h7:=0;
          h6:=rtlsdr_set_bias_tee(sdropennum, h7);
          mlauf:=0;
          Closestat:=0;
          mtasts:=1;
        end;
      end else begin
        Label2.Caption:='Auswahl ist leer, neu wählen';
        Form1.ActiveControl:=ComboBox1;
      end;
    end else begin
      Label2.Caption:='SDR-Device muss ausgewählt werden';
      Form1.ActiveControl:=ComboBox1;
    end;
  end;
end;

{
  Procedure FormCloseQuery
      Fragt nach, ob das Programm beendet werden soll.
      Wenn Abfrage mit "No" beantwortet wird geht es ganz normal im Programm weiter.
      Außer wenn abbruch = True ist, dann wird sofort beendet.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Zeile1(Form1.Label1);
  if (abbruch) then
  begin
    CanClose:=true;
  end else begin
    Form1.Cursor:=crDefault;
    Form1.Refresh;
    CanClose:=false;
    if (Closestat = 0) then
    begin
      JaNein:=QuestionDlg('Entscheidung', 'Programm-Ende', mtConfirmation, [mrYes, 'Ja', mrNo, 'Nein'], 0);
      if (JaNein = mrYes) then
      begin
        CanClose:=true;
      end;
    end;
  end;
end;

end.

